/*******************************************************************************
  Filename:     eval.js

  Created:      26 August 2006 (20:43:14)
  Created by:   Jan Schreiber (a.k.a. MrSpock)
  Last Updated: 31 January 2007

  Comments:     Adds several ways to evaluate the selected text via JScript.
                The result can be displayed in a message box, appended to the
                selection, or replace it.

*******************************************************************************/

module_name = "js_eval";
menu_name = "Eval (JScript)"
module_ver = "2.0";

function Init()
{
  addMenuItem("eval (result in MsgBox)", menu_name, "eval_echo", "Alt+Shift+E");
  addMenuItem("eval (replace selection)", menu_name, "eval_replace");
  addMenuItem("eval (append to selection)", menu_name, "eval_append");
  addMenuItem("-", menu_name, "");
  addMenuItem("Edit script", menu_name, "openScript");
}

function eval_echo()
{
  var obj1 = newEditor();
  try
  {
    obj1.assignActiveEditor();
  }
  catch(e)
  {
    return;
  }
  var inpString = obj1.SelText();
  if (inpString == "")
  {
    inpString = inputText("Please enter a valid JScript expression:");
    if (inpString == "") return;
  }
  try
  {
    var outputString = eval(inpString);
    echo(outputString);
  }
  catch(e)
  {
    echo(e);
    return;
  }
}

function eval_replace()
{
  var obj1 = newEditor();
  try
  {
    obj1.assignActiveEditor();
  }
  catch(e)
  {
    return;
  }
  var inpString = obj1.SelText();
  if (inpString == "")
  {
    inpString = inputText("Please enter a valid JScript expression:");
    if (inpString == "") return;
  }
  try
  {
    var outputString = eval(inpString);
    obj1.SelText(outputString);
  }
  catch(e)
  {
    echo(e);
    return;
  }
}

function eval_append()
{
  var obj1 = newEditor();
  try
  {
    obj1.assignActiveEditor();
  }
  catch(e)
  {
    return;
  }
  var inpString = obj1.SelText();
  if (inpString == "")
  {
    inpString = inputText("Please enter a valid JScript expression:");
    if (inpString == "") return;
  }
  try
  {
    var outputString = eval(inpString);
    obj1.SelText(inpString + "=" + outputString);
  }
  catch(e)
  {
    echo(e);
    return;
  }
}

function openScript()
{
  var obj1 = newEditor();
  obj1.openFile(moduleFileName("js_eval"));
}
